#!/usr/bin/env ruby

require 'json'
require 'open-uri'

VERSION="2.11.2"

def depends(name)


	if name.key?("dependencies") then

		name["dependencies"].each do |key, value|

			File.open("deps.txt","a+") do |f|
				f.puts key + "=" + value["version"]
			end

			url = value["resolved"]
			pkg = key + "-" + value["version"] + ".tgz"	


			Dir.chdir("deps") do |dir|
				unless url == nil then
					open(pkg, 'w'){|f| f << open(url).read}
					p "downloaded dependency: " + pkg
				else
					url = "http://registry.npmjs.org/" + key + "/-/" + pkg
					open(pkg, 'w'){|f| f << open(url).read}
					p "downloaded dependency: " + pkg
				end
			end

			depends(value)

		end

	end	

end

if File.exist?("/usr/bin/npm") then

	url = "http://registry.npmjs.org/npm/-/npm-" + VERSION + ".tgz"

	name = "npm-" + VERSION + ".tgz"

	open(name, 'w'){|f| f << open(url).read}

	if (system "tar -xf #{name}") then

		Dir.chdir("package") do |dir|

			system "npm shrinkwrap"

		end

	end

	io = File.read("package/npm-shrinkwrap.json")

	hash = JSON.parse(io)

	Dir.mkdir("deps") unless Dir.exists?("deps")

	depends(hash)

else

	p 'npm not installed! please "sudo zypper in npm" first!'

end
