#
# spec file for package npm
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           npm
Version:        2.11.3
Release:        18.1
Summary:        Node.js Package Manager
License:        Artistic-2.0
Group:          Development/Tools
Url:            http://npmjs.org/
Source:         http://registry.npmjs.org/npm/-/npm-%{version}.tgz
Source99:       npm.rb
# use system paths for man pages and documentation
Patch1:         %{name}-doc-path.diff
# use external node-gyp because the internal will be removed
Patch2:         npm-external-node-gyp.patch
BuildRequires:  fdupes
BuildRequires:  nodejs-packaging
Conflicts:      otherproviders(npm(npm))
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildArch:      noarch
%nodejs_find_provides_and_requires

%description
npm is a package manager for node.js. You can use it to install and publish your
node programs. It manages dependencies and does other cool stuff.

%prep
%setup -q -n package
%patch1 -p1
%patch2 -p1
%nodejs_fixdep normalize-package-data '~2.3.1'
%nodejs_fixdep request '~2.60.0'
%nodejs_fixdep readable-stream '~2.0.2'
%nodejs_fixdep init-package-json '~1.7.0'

#remove bundled modules
rm -rf node_modules

#remove bundled node-gyp
rm -rf bin/node-gyp-bin

#remove unnessary npm
rm -rf bin/npm

#add a missing shebang
sed -i -e '1i#!%{_bindir}/node' bin/read-package-json.js

# delete windows stuff
rm bin/npm.cmd

# override some defaults
./configure globalconfig=%{_sysconfdir}/npmrc globalignorefile=%{_sysconfdir}/npmignore

%build
#nothing to do

%install
mkdir -p %{buildroot}%{nodejs_sitelib}/npm
cp -pr bin lib cli.js package.json %{buildroot}%{nodejs_sitelib}/npm/

mkdir -p %{buildroot}%{_bindir}
ln -sf %{_libexecdir}/node_modules/npm/bin/npm-cli.js %{buildroot}%{_bindir}/npm

# ghosted global config files
mkdir -p %{buildroot}%{_sysconfdir}
touch %{buildroot}%{_sysconfdir}/npmrc
touch %{buildroot}%{_sysconfdir}/npmignore

# install to mandir
mkdir -p %{buildroot}%{_mandir}
cp -pr man/* %{buildroot}%{_mandir}/

mkdir -p %{buildroot}%{_docdir}/%{name}
mkdir -p %{buildroot}%{nodejs_sitelib}/npm/{doc,html}
cp -rp AUTHORS README.md LICENSE CHANGELOG.md CONTRIBUTING.md %{buildroot}%{_docdir}/%{name}
cp -r doc %{buildroot}%{nodejs_sitelib}/npm/doc
cp -r html %{buildroot}%{nodejs_sitelib}/npm/html

find %{buildroot} -name "*.orig" -delete -print
%fdupes %{buildroot}

%files
%defattr(-,root,root,-)
%{nodejs_sitelib}/npm
%ghost %{_sysconfdir}/npmrc
%ghost %{_sysconfdir}/npmignore
%{_bindir}/npm
%{_mandir}/man*/*
%{_docdir}/%{name}

%changelog
* Fri Jul 31 2015 i@marguerite.su
- fix: rpm can't change a directory to a symlink
  * That /usr/lib/node_modules/npm/doc exists before installing npm
    is because: npm requires nodejs-packaging to build, which
    further requires nodejs-npm (the built in npm), which holds
    the doc directory. then because it's an existing place, rpm
    can't delete and symlink it to /usr/share/doc/packages/npm/doc
  * https://bugzilla.redhat.com/show_bug.cgi?id=447156
  * another workaround:
    https://bugs.launchpad.net/rpm/+bug/633636/comments/3
  * but we still want to keep our specfile simple, so we just
    not to symlink doc and html directories.
* Wed Jul 29 2015 i@marguerite.su
- update version 2.11.3
- fix boo#937854: request < 2.58
* Fri Jun  5 2015 i@marguerite.su
- update version 2.11.2
- add npm.rb, which is a powerful tool to help maintainers
  surviving npm's dependencies' update cycle.
* Thu Apr 23 2015 hvogel@suse.com
- Update to version 2.8.3. For details see the included
  CHANGELOG.md
- drop npm-deps.diff
* Sat Apr  4 2015 dmueller@suse.com
- enable building for all arches
* Fri Oct 10 2014 jgleissner@suse.com
- update to version 2.1.3
- add patch: npm-deps.diff
  * be less strict about version numbers of some dependencies
* Thu Oct  9 2014 jgleissner@suse.com
- use nodejs-packaging for building
* Wed Sep 24 2014 i@marguerite.su
- add patch: npm-external-node-gyp.patch
  * npm force used internel bundled node-gyp.js, which was removed
    during packaging
* Mon Sep 22 2014 i@marguerite.su
- clean specfile
* Mon Sep 22 2014 jgleissner@suse.com
- update to npm 2.0.0
* Wed Aug 20 2014 jgleissner@suse.com
- initial builds
